#!/usr/bin/env python
"""
Author: Jun Ding
Date: NOV.3,2011
Version: 1.0
function: this code is used to obtained the score cutoff for given pwm under certain
occurence lambda.
usage: python.get_lambda.py <input_seq_random_permutated><motif><cutoff><outputdir>
"""
def MotifScan1(seqs,mot,reg):
	data=[0]*len(reg)
	minscore=reg[0]
	maxscore=reg[len(reg)-1]
	bk=[0,0,0,0]
	bk[0]=0.290763621993511
	bk[1]=0.202156441211073
	bk[2]=0.205656409776978
	bk[3]=0.301423527018438
	for seq in seqs:
		hit_position=[]
		if len(seq)-len(mot)>=0:
			for i in range(len(seq)-len(mot)+1):
				score_i=0
				for j in range(len(mot)):
					if seq[i+j]=='A':
						score_i=score_i+math.log(mot[j][0]/(bk[0]))
					elif seq[i+j]=='C':
						score_i=score_i+math.log(mot[j][1]/(bk[1]))
					elif seq[i+j]=='G':
						score_i=score_i+math.log(mot[j][2]/(bk[2]))
					elif seq[i+j]=='T':
						score_i=score_i+math.log(mot[j][3]/(bk[3]))
					else:
						score_i=score_i+0
				if (score_i<maxscore)&(score_i>minscore):
					tmp=(score_i-minscore)/0.0001
					tmp=math.floor(tmp)
				elif score_i<=minscore:
						tmp=0
				else:
					tmp=len(data)-1
				data[int(tmp)]+=1
		else:
			print('error! sequences is shorter than motif')
	return data

import pdb,sys,os

import math
outputdir=sys.argv[4]
#read in input_SEQ
f=open(sys.argv[1],'r')
lf=f.readlines()
f.close()
lf="".join(lf)
lf=lf.split(">")[1:]
for i in range(len(lf)):
	lf[i]=lf[i].split("\n")
	lf[i]=[item for item in lf[i] if item!=""]
	lf[i]=lf[i][1:]
	lf[i]="".join(lf[i])
seq=lf
#get length
sum_len=0
for i in range(len(seq)):
	sum_len+=len(seq[i])

#read in motifs
f=open(sys.argv[2],'r')
lf=f.readlines()
f.close()
lf=''.join(lf)
lf=lf.split('>')[1:]
lf=[item.split('\n') for item in lf]
for i in range(len(lf)):
	lf[i]=[item for item in lf[i] if item!=""]
motifs=[]	
# get lambda
for i in lf:
	t=i[1:]
	t=[item.split(' ') for item in t]  ## note motif format
	motifs.append(t)

lam=[]
bk=[0,0,0,0]
bk[0]=0.290763621993511
bk[1]=0.202156441211073
bk[2]=0.205656409776978
bk[3]=0.301423527018438

cutoff=float(sys.argv[3])
for i in range(len(motifs)):
	score_i=0
	num_i=0.0
	score_i2=0
	for j in range(len(motifs[i])):
		motifs[i][j]=[float(item) for item in motifs[i][j]]
		index_max=motifs[i][j].index(max(motifs[i][j]))
		score_i+=math.log(max(motifs[i][j])/bk[index_max])
		index_min=motifs[i][j].index(min(motifs[i][j]))
		score_i2+=math.log(min(motifs[i][j])/bk[index_max])
	max_score_i=score_i
	min_score_i=score_i2
	leng=max_score_i-min_score_i
	M=leng*10000
	M=int(M)
	reg=[]
	tmp=min_score_i
	reg.append(tmp)
	for nn in range(M):
		tmp=tmp+0.0001
		reg.append(tmp)
	
	data=MotifScan1(seq,motifs[i],reg)
	num=0
	for kk in range(len(data)-1,0,-1):
		num+=data[kk]
		if num>(sum_len)*cutoff:
			break
	score_i=reg[kk]
	la_i=num*1.0/(sum_len)
	sys.stdout.write(".")
	sys.stdout.flush()
	lam.append(str(score_i)+'\t'+str(la_i))
print ("\n")
lam='\n'.join(lam)
sys.argv[2]=sys.argv[2].split('/')[-1]
f=open(outputdir+"/"+sys.argv[2]+'_lambda','w')
f.write(lam)
f.close()	
	


